import java.awt.*;
import ColecoVision;

//
//
// EmulPropDlg
//
//
class EmulPropDlg extends Dialog
{
	private ColecoVision	m_cv = null;

	private Button	m_APPLY = null;
	private Button m_OK = null;
	private Button m_CANCEL = null;

	private Choice m_SPEEDCHOICE = null;
	private Checkbox m_LOCKCPU = null;
	private TextField m_SKIPRATE = null;
	private TextField m_NMIFREQ = null;

	public EmulPropDlg(Frame parent, boolean modal, ColecoVision cv)
	{
		super(parent, "Emulation Properties", modal);
		m_cv = cv;

		// Initially 320x240 using border layout
		resize(320,240);
		setLayout(new BorderLayout());
		setResizable(true);

		// Create contents panel and components...
		Panel	contents = new Panel();
		contents.setLayout(new FlowLayout(FlowLayout.LEFT, 10, 10));
		contents.resize(320, 175);

		// CONTENTS_BEGIN
		contents.add(new Label("CPU emulation speed control method:"));
		m_SPEEDCHOICE = new Choice();
		m_SPEEDCHOICE.addItem("NONE");
		m_SPEEDCHOICE.addItem("DYNAMIC");
		m_SPEEDCHOICE.select(m_cv.getVideoSyncMethod());
		contents.add(m_SPEEDCHOICE);
		
		m_LOCKCPU = new Checkbox("Lock CPU emulation at 3.58Mhz");
		m_LOCKCPU.setState(m_cv.isCPUSpeedLocked());
		contents.add(m_LOCKCPU);

		contents.add(new Label("NMI generation frequency:"));
		m_NMIFREQ = new TextField(String.valueOf(m_cv.getVideoRefreshFreq()),
								2);
		contents.add(m_NMIFREQ);

		contents.add(new Label("Video refresh skip rate:"));
		m_SKIPRATE = new TextField(String.valueOf(m_cv.getVideoRefreshSkipRate()),
								2);
		contents.add(m_SKIPRATE);

		//	CONTENTS_END
		add("Center", contents);

		Panel bottom = new Panel();
		bottom.setLayout(new FlowLayout(FlowLayout.RIGHT));

		m_OK = new Button("OK");
		m_OK.resize(50,14);
		bottom.add(m_OK);

		m_CANCEL = new Button("Cancel");
		m_CANCEL.resize(50,14);
		bottom.add(m_CANCEL);

		// Create the OK, Cancel, and apply buttons.
		m_APPLY = new Button("Apply");
		m_APPLY.resize(50,14);
		bottom.add(m_APPLY);

		add("South", bottom);
	}

	public boolean handleEvent(Event evt)
	{
		switch(evt.id)
		{
			case	Event.WINDOW_DESTROY:
				dispose();
				return true;

			case Event.ACTION_EVENT:
				if (	m_OK==evt.target ||
						m_APPLY==evt.target
					)
				{
					if (m_SPEEDCHOICE.getSelectedItem().equalsIgnoreCase("NONE"))
						m_cv.setVideoSyncMethod(ColecoVision.m_TSM_EMULATEDCPU);
					else
						m_cv.setVideoSyncMethod(ColecoVision.m_TSM_TIMEDCPU);

					m_cv.lockCPUSpeed(m_LOCKCPU.getState());

					m_cv.setVideoRefreshFreq(Integer.parseInt(m_NMIFREQ.getText()));
					m_cv.setVideoRefreshSkipRate(Integer.parseInt(m_SKIPRATE.getText()));
				}

				if (m_OK==evt.target || m_CANCEL==evt.target)
					postEvent(new Event(this, Event.WINDOW_DESTROY, null));
				return true;

			default:
				return super.handleEvent(evt);
		}
	}
}

