//******************************************************************************
// VColecoFrame.java:	
//
//******************************************************************************
import java.awt.*;
import VColecoJava;

//==============================================================================
// STANDALONE APPLICATION SUPPORT
// 	This frame class acts as a top-level window in which the applet appears
// when it's run as a standalone application.
//==============================================================================
class VColecoFrame extends Frame
{
	private Menu		m_FILE;
	private MenuItem	m_FILE_OPEN;
	private MenuItem	m_FILE_CLOSE;

	private Menu		m_EMULATION;
	private MenuItem	m_EMULATION_RESET;
	private CheckboxMenuItem	m_EMULATION_PAUSE;
	private MenuItem	m_EMULATION_PROPERTIES;

	private Menu		m_HELP;
	private MenuItem	m_HELP_ABOUT;

	// VColecoFrame constructor
	//--------------------------------------------------------------------------
	public VColecoFrame(String str)
	{
		// TODO: Add additional construction code here
		super (str);

		MenuBar mb = new MenuBar();
		m_FILE = new Menu("File");
			m_FILE_OPEN = new MenuItem("Open cartridge ROM...");
			m_FILE_CLOSE = new MenuItem("Exit");
			m_FILE.add(m_FILE_OPEN);
			m_FILE.add(m_FILE_CLOSE);

		m_EMULATION = new Menu("Emulation");
			m_EMULATION_RESET = new MenuItem("Reset");
			m_EMULATION_PAUSE = new CheckboxMenuItem("Pause");
			m_EMULATION_PROPERTIES = new MenuItem("Properties...");
			m_EMULATION.add(m_EMULATION_RESET);
			m_EMULATION.add(m_EMULATION_PAUSE);
			m_EMULATION.add(new MenuItem("-"));
			m_EMULATION.add(m_EMULATION_PROPERTIES);

		m_HELP = new Menu("Help");
			m_HELP_ABOUT = new MenuItem("About...");
			m_HELP.add(m_HELP_ABOUT);

		mb.add(m_FILE);
		mb.add(m_EMULATION);
		mb.add(m_HELP);

		setMenuBar(mb);
	}

	// The handleEvent() method receives all events generated within the frame
	// window. You can use this method to respond to window events. To respond
	// to events generated by menus, buttons, etc. or other controls in the
	// frame window but not managed by the applet, override the window's
	// action() method.
	//--------------------------------------------------------------------------
	public boolean handleEvent(Event evt)
	{
		switch (evt.id)
		{
			// Application shutdown (e.g. user chooses Close from the system menu).
			//------------------------------------------------------------------
			case Event.WINDOW_DESTROY:
				// TODO: Place additional clean up code here
				dispose();
				System.exit(0);
				return true;

			case Event.ACTION_EVENT:
				try
				{
					VColecoJava cej = (VColecoJava) getComponent(0);

					if (m_FILE_OPEN==evt.target)
						cej.OnFILE_OPEN(this);
					else if (m_FILE_CLOSE==evt.target)
					{
						dispose();
						System.exit(0);
					}
					else if (m_EMULATION_RESET==evt.target)
						cej.OnEMULATION_RESET();
					else if (m_EMULATION_PAUSE==evt.target)
						cej.OnEMULATION_PAUSE();
					else if (m_EMULATION_PROPERTIES==evt.target)
						cej.OnEMULATION_PROPERTIES(this);
					else if (m_HELP_ABOUT==evt.target)
						cej.OnHELP_ABOUT(this);
				}
				catch(Exception e)
				{
				}
				return true;

			default:
				return super.handleEvent(evt);
		}			 
	}
}
